/*=================================================================================
	int.c
-----------------------------------------------------------------------------------
	LEDVtg_vOBXCb`xɃVtg_xύXłB
=================================================================================*/

#include <p30f5011.h>				//vZbTwb_t@C,TRISBPORTB`Ă
#include "lcd.h"					//LCDp֐̃vg^Cv錾

//	Configuration bits ----------------------------------------------------------
_FOSC(CSW_FSCM_OFF & FRC_PLL8);		//RCiNbNj8{, NbNj^[OFF
_FWDT(WDT_OFF);						//EHb`hbO^C}[OFF
_FBORPOR(PBOR_OFF & MCLR_EN);		//uEAEgZbgOFF, }X^[NAL
_FGS(CODE_PROT_OFF);				//R[hیOFF
//-------------------------------------------------------------------------------

#define NULL 0x00					//NULL0x00Ƃ

int t = 500;						//LEDVtg_xAl500ms/bit
char lcddata[12];					//LCDpf[^
int val = 2;						//LEDVtg_x̃x={0,1,2}

int main(void)
{
	unsigned int shiftdata=0x0003;	//Vtgf[^ۑϐ

	TRISB = 0xffc0;					//RB5-RB0Fo
	TRISD = 0xff00;					//RD11-RD8F,RD7-RD0Fo

	SR = ((SR & 0xff1f) | 0x0020);	//MPU荞ݗDx1ɐݒ
	INTCON1 = 0x8000;				//d荞݋֎~
	INTCON2 = 0x0000;				//IVTgpAINT1̊荞݂͗オGbWƂ
	IPC4 = ((IPC4 & 0xfff8) | 0x0005);	//INT1荞ݗDx5ɐݒ
	IFS1 = (IFS1 & 0xfffe);			//INT1荞݃tONA
	IEC1 = ((IEC1 & 0xfffe) | 0x0001);	//INT1荞݋,RD8sINT1ɂȂ

	InitLCD();						//LCD

	PrintLCD("LED Shift\n");		//LCD1sڂɕ\ĉs
	lcddata[0] = '0' + t % 10000 / 1000;	//10i4
	lcddata[1] = '0' + t % 1000 / 100;		//10i3
	lcddata[2] = '0' + t % 100 / 10;		//10i2
	lcddata[3] = '0' + t % 10;				//10i1
	lcddata[4] = ' ';
	lcddata[5] = 'm';
	lcddata[6] = 's';
	lcddata[7] = '/';
	lcddata[8] = 'b';
	lcddata[9] = 'i';
	lcddata[10] = 't';
	lcddata[11] = NULL;				//̏I
	PrintLCD(lcddata);				//LCDlcddata̓e\

	while(1){
		shiftdata = (shiftdata << 1)|(shiftdata >> 7);	//1rbgVtg
		PORTD = shiftdata;			//shiftdata̓e|[gRDɏo͂
		wait(t);					//t ms҂
	}
	return 0;
}

void __attribute__((interrupt)) _INT1Interrupt(void)
{
	int buff[5]={0,0,0,0,0};	//buffFINT1̓͒lz

	//ȈՃ`^O΍
	while(1){
		buff[4] = buff[3];	//INT1̓͒lVtg
		buff[3] = buff[2];	//buff[4]=>ŏ̓͒l,buff[0]=>Ō̓͒l
		buff[2] = buff[1];
		buff[1] = buff[0];
		buff[0] = (PORTD & 0x0100);	//RD8(INT1)ȊO}XN
		//5'H'xoA[v𔲂B
		if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
		wait(1);	//1ms҂
	}

	IFS1 = (IFS1 & 0xfffe);			//INT1荞݃tONA

	switch(val){					//_LEDVtgx̕ύX
		case 0:		t=200;			//200ms/dot
					val++;			//xx1ɂ
					break;
		case 1:		t=500;			//500ms/dot
					val++;			//xx2ɂ
					break;
		case 2:		t=1000;			//1000ms/dot
					val=0;			//xx0ɂ
					break;
		default:	t=500;			//500ms/dot
					val=2;			//xx2ɂ
					break;
	}

	//LCD\XV
	lcddata[0] = '0' + t % 10000 / 1000;	//10i4
	lcddata[1] = '0' + t % 1000 / 100;		//10i3
	lcddata[2] = '0' + t % 100 / 10;		//10i2
	lcddata[3] = '0' + t % 10;				//10i1
	LocateLCD(0,1);					//LCD2sڂ̐擪ɃJ[\߂
	PrintLCD(lcddata);				//LCDlcddata̓e\
}
